<script type="text/javascript">
  (async function() {
    if (!window.dimXmlPromise) {
      const prom = {};
      prom.promise = new Promise((resolve) => (prom.resolve = resolve));
      window.dimXmlPromise = prom;
      /* will be resolved by DimXmlConf script */
    }

    const dimXml = await dimXmlPromise.promise;
    dimXml.utils.genNodeTemplate("dim-xml-params-client", {
      nodeName: {
        property: "name",
        label: RED._('node-red-dim-xml/dicXmlParams:dicXmlParams.label.node-name')
      },
      nodeConf: {
        property: "cnf",
        label: RED._('node-red-dim-xml/dicXmlParams:dicXmlParams.label.node-conf')
      },
      service: {
        property: "serviceName",
        label: RED._('node-red-dim-xml/dicXmlParams:dicXmlParams.label.service')
      },
      checkboxes: [
        {
          property: "stamped",
          label: RED._('node-red-dim-xml/dicXmlParams:dicXmlParams.label.opt-stamped'),
          inline: false
        },
        {
          property: "monitored",
          label: RED._('node-red-dim-xml/dicXmlParams:dicXmlParams.label.opt-monitored'),
          inline: true
        },
        {
          property: "scheduled",
          label: RED._('node-red-dim-xml/dicXmlParams:dicXmlParams.label.opt-scheduled'),
          inline: true
        },
      ],
      stdInputs: [
        {
          property: "timeout",
          label: RED._('node-red-dim-xml/dicXmlParams:dicXmlParams.label.timeout'),
          icon: RED._('node-red-dim-xml/dicXmlParams:dicXmlParams.label.timeout-icon'),
          placeholder: RED._('node-red-dim-xml/dicXmlParams:dicXmlParams.default.timeout'),
          unit: RED._('node-red-dim-xml/dicXmlParams:dicXmlParams.label.timeout-unit'),
          width: "100px"
        }
      ]
    });

    RED.nodes.registerType("dim-xml-params-client", {
      category: 'network',
      color: '#F38B68',
      defaults: {
        name: { value: "" },
        cnf: { type: "dim-xml-conf", required: true },
        serviceName: { value: "", required: true,
          validate: RED.validators.regex(dicXml.regExp.srvName)
        },
        monitored: { value: false },
        scheduled: { value: false },
        timeout: {
          value: RED._('node-red-dim-xml/dicXmlParams:dicXmlParams.default.timeout') },
        stamped: { value: false },
      },
      icon: 'bridge.svg',
      inputs: 1,
      outputs: 1,
      button: {
        onclick: function() {
          dimXml.utils.getSingleValue(this);
        },
        enabled: function() {
          return !this.changed;
        }
      },
      oneditprepare: function() {
        const node = this;
        $("#node-input-timeout").typedInput({
          type: "num",
          types: ["num"]
        });

        dimXml.utils.enableInputByCheckbox(node, 'timeout', 'scheduled');

        const ddl = dimXml.utils.initDropDownList();
        if (ddl) {
          const updateDdl = async () => {
            const srvList = await dimXml.utils.serviceList();

            /* service list filtering */
            let filteredList = [];
            if (Array.isArray(srvList)) {
              srvList.forEach(s => {
                if (s.type === 'SRV' && s.definition === 'C' &&
                  s.name.endsWith('/Aqn')) {
                  filteredList.push(s.name.split('/Aqn')[0]);
                }
              });
            }

            ddl.append(filteredList);
          }
          updateDdl();

          $('#node-input-cnf').one('focus', function() {
            $(this).change(function() {
              ddl.clear();
              updateDdl();
            });
          });
        }
      },
      label: function() {
        return dimXml.utils.getLabel(this, "DIM-XML Parameters Client");
      }
    });
  }());
</script>

<script type="text/html" data-template-name="dim-xml-params-client"></script>
